<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Views/RawFile.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Views/RawFile.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Views/RawFile.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Parameter</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.View <span class="py-keyword">import</span> View</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Directory <span class="py-keyword">import</span> compile_glob</span>
<a id="line13"></a><span class="lineno"> 13</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">import</span> time, os, stat, os.path</span>
<a id="line15"></a><span class="lineno"> 15</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/RawFile/RawFile.html">RawFile</a>(View):</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A module for creating a view for each file with hyperlinked source&quot;&quot;&quot;</span></span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">    src_dir = Parameter(<span class="py-string">''</span>, <span class="py-string">'starting point for directory listing'</span>)</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">    base_path = Parameter(<span class="py-string">''</span>, <span class="py-string">'path prefix to strip off of the file names'</span>)</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">    exclude = Parameter([], <span class="py-string">'TODO: define an exclusion mechanism (glob based ?)'</span>)</span>
<a id="line22"></a><span class="lineno"> 22</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/RawFile/RawFile.html#register">register</a>(self, frame):</span>
<a id="line24"></a><span class="lineno"> 24</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">        super(RawFile, self).register(frame)</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">        self._exclude = [compile_glob(e) <span class="py-keyword">for</span> e <span class="py-keyword">in</span> self.exclude]</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">        self.__files = None</span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/RawFile/RawFile.html#filename">filename</a>(self):</span>
<a id="line30"></a><span class="lineno"> 30</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">        <span class="py-keyword">return</span> self.__filename</span>
<a id="line32"></a><span class="lineno"> 32</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/RawFile/RawFile.html#title">title</a>(self):</span>
<a id="line34"></a><span class="lineno"> 34</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">        <span class="py-keyword">return</span> self.__title</span>
<a id="line36"></a><span class="lineno"> 36</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/RawFile/RawFile.html#_get_files">_get_files</a>(self):</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns a list of (path, output_filename) for each file.&quot;&quot;&quot;</span></span>
<a id="line39"></a><span class="lineno"> 39</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">        <span class="py-keyword">if</span> self.__files <span class="py-keyword">is</span> <span class="py-keyword">not</span> None: <span class="py-keyword">return</span> self.__files</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">        self.__files = []</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">        dirs = [self.src_dir]</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">        <span class="py-keyword">while</span> dirs:</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">            dir = dirs.pop(0)</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">            <span class="py-keyword">for</span> entry <span class="py-keyword">in</span> os.listdir(os.path.abspath(dir)):</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">                exclude = 0</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">                <span class="py-keyword">for</span> re <span class="py-keyword">in</span> self._exclude:</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">                    <span class="py-keyword">if</span> re.match(entry):</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">                        exclude = 1</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">                        <span class="py-keyword">break</span></span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">                <span class="py-keyword">if</span> exclude:</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">                    <span class="py-keyword">continue</span></span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">                entry_path = os.path.join(dir, entry)</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">                info = os.stat(entry_path)</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">                <span class="py-keyword">if</span> stat.S_ISDIR(info[stat.ST_MODE]):</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">                    dirs.append(entry_path)</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">                <span class="py-keyword">else</span>:</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">                    <span class="py-comment"># strip of base_path</span></span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">                    path = entry_path[len(self.base_path):]</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">                    <span class="py-keyword">if</span> path[0] == <span class="py-string">'/'</span>: path = path[1:]</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">                    filename = self.directory_layout.file_source(path)</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">                    self.__files.append((entry_path, filename))</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">        <span class="py-keyword">return</span> self.__files</span>
<a id="line64"></a><span class="lineno"> 64</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/RawFile/RawFile.html#process">process</a>(self):</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Creates a view for every file.&quot;&quot;&quot;</span></span>
<a id="line67"></a><span class="lineno"> 67</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">        <span class="py-keyword">for</span> path, filename <span class="py-keyword">in</span> self._get_files():</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">            self.process_file(path, filename)</span>
<a id="line70"></a><span class="lineno"> 70</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/RawFile/RawFile.html#register_filenames">register_filenames</a>(self):</span>
<a id="line72"></a><span class="lineno"> 72</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">        <span class="py-keyword">for</span> path, filename <span class="py-keyword">in</span> self._get_files():</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">            self.processor.register_filename(filename, self, path)</span>
<a id="line75"></a><span class="lineno"> 75</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/RawFile/RawFile.html#process_file">process_file</a>(self, original, filename):</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Creates a view for the given filename.&quot;&quot;&quot;</span></span>
<a id="line78"></a><span class="lineno"> 78</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">        <span class="py-comment"># Check that we got the rego</span></span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">        reg_view, reg_scope = self.processor.filename_info(filename)</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">        <span class="py-keyword">if</span> reg_view <span class="py-keyword">is</span> <span class="py-keyword">not</span> self: <span class="py-keyword">return</span></span>
<a id="line82"></a><span class="lineno"> 82</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">        self.__filename = filename</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">        self.__title = original[len(self.base_path):]</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">        self.start_file()</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">        self.write_navigation_bar()</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">        self.write(<span class="py-string">'File: '</span>+element(<span class="py-string">'b'</span>, self.__title))</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">        <span class="py-keyword">try</span>:</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">            lines = open(original, <span class="py-string">'rt'</span>).readlines()</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">            lineno_template = <span class="py-string">'%%%ds'</span> % len(`len(lines)`)</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">            lines = [<span class="py-string">'&lt;span class=&quot;lineno&quot;&gt;%s&lt;/span&gt;&lt;span class=&quot;line&quot;&gt;%s&lt;/span&gt;\n'</span></span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">                     %(lineno_template % (i + 1), escape(l[:-1]))</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">                     <span class="py-keyword">for</span> i, l <span class="py-keyword">in</span> enumerate(lines)]</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">            self.write(<span class="py-string">'&lt;pre class=&quot;sxr&quot;&gt;'</span>)</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">            self.write(<span class="py-string">''</span>.join(lines))</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">            self.write(<span class="py-string">'&lt;/pre&gt;'</span>)</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">        <span class="py-keyword">except</span>:</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">            self.write(<span class="py-string">'An error occurred'</span>)</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">        self.end_file()</span>
<a id="line100"></a><span class="lineno">100</span>
<a id="line101"></a><span class="lineno">101</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:14 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
